#ifndef  MODULES_SCREEN_H
#define  MODULES_SCREEN_H

/*
**   screen.h
**
**   (C) Copyright 2003 Rocklyte Systems.
**       All Rights Reserved.
*/

#ifndef  MAIN_H
#include <pandora/main.h>
#endif

#define MODVERSION_SCREEN ((FLOAT)1.0)

struct ScreenInfoV1 {
   OBJECTID ScreenID;  /* Object ID related to the screen display */
   LONG Flags;         /* Screen flags (RNF_VISIBLE etc) */
   WORD Width;         /* Width */
   WORD Height;        /* Height */
   WORD BitsPerPixel;
   WORD BytesPerPixel;
   LONG AmtColours;
   LARGE AccelFlags;
};

typedef struct ScreenInfoV2 {
   OBJECTID ScreenID;  /* Object ID related to the screen display */
   LONG Flags;         /* Screen flags (RNF_VISIBLE etc) */
   WORD Width;         /* Width */
   WORD Height;        /* Height */
   WORD BitsPerPixel;
   WORD BytesPerPixel;
   LONG AmtColours;
   LARGE AccelFlags;
   struct {               /* Same structure as struct ColourFormat */
      UBYTE  RedShift;    /* Right shift value */
      UBYTE  BlueShift;
      UBYTE  GreenShift;
      UBYTE  AlphaShift;
      UBYTE  RedMask;     /* The unshifted mask value (ranges from 0x00 to 0xff) */
      UBYTE  GreenMask;
      UBYTE  BlueMask;
      UBYTE  AlphaMask;
      UBYTE  RedPos;      /* Left shift/positional value */
      UBYTE  GreenPos;
      UBYTE  BluePos;
      UBYTE  AlphaPos;
   } PixelFormat;
};

typedef struct ScreenInfoV2 SCREENINFO;

//#define ScreenInfo ScreenInfoV2

/*****************************************************************************/

#define ACF_VIDEOBLIT    0x0000000000000001
#define ACF_SOFTWAREBLIT 0x0000000000000002

/*****************************************************************************
** Function Table.
*/

#ifndef LOCAL_SCREEN

struct ScreenBase {
   ERROR (*GetScreenInfo)(OBJECTID, SCREENINFO *, LONG);
};

#define GetScreenInfo(a,b,c)  (ScreenBase->GetScreenInfo(a,b,c))

#else

static ERROR GetScreenInfo(OBJECTID, SCREENINFO *, LONG);

#endif /* LOCAL_SCREEN */

#endif /* MODULES_SCREEN_H */
